<?php

$title="Display Info"; 
include ("prolog.php");

$vidmod=file_get_contents(sysfs_vout_device() . "vid_mode");
$dpm_state=file_get_contents(sysfs_vout_device() . "dpm_state");
$sets=explode ("=",$vidmod);
if (count($sets)==2){
	$vals=explode (" ",trim($sets[1]));
	if (count($vals)>=11){
		echo "<h2>Display Settings: </h2>\n<table>\n";
		if ($vals[11]=="0:0") $vals[11]="[auto]";
		if ($vals[11]=="x:x") $vals[11]="[unknown]";
		print ("<tr><td>Resolution : </td><td>".htmlspecialchars($vals[0])."x".htmlspecialchars($vals[1])."</td></tr>\n");
		print ("<tr><td>Vertical refresh : </td><td>".htmlspecialchars($vals[2])." Hz</td></tr>\n");
		print ("<tr><td>Aspect ratio : </td><td>".htmlspecialchars($vals[11])."</td></tr>\n");
		print ("<tr><td>Power save : </td><td>".($dpm_state[0]=="0"?"On":"Off")."</td></tr>\n");
		echo "</table>\n";
	}
}

$dir=sysfs_vout_device();
$content=scandir($dir);
foreach($content as $path){
	if (strncmp($path,"out",3)==0){
		$data=array("mon_powered","mon_manufacturer","mon_prod_id", "mon_name","mon_serial_no", "mon_width","mon_height","mon_underscan","mon_audio","mon_pict_ar" );
		$name=file_get_contents("$dir$path/name");
		$mon_present=file_get_contents("$dir$path/mon_present");
		echo "<h2>", htmlspecialchars($name), " Output</h2><br/>\n";
		if ($mon_present==1) {
			foreach ($data as $d){
				${$d}=file_get_contents($dir.$path."/$d");
				if (!isset(${$d})) ${$d}="";
			}
			if ($mon_manufacturer!="" || $mon_name!="") echo "Display Info: <ul><li>Manufacturer: ", htmlspecialchars($mon_manufacturer), "</li><li>Product ID: ", htmlspecialchars($mon_prod_id), "</li><li>Name: ", htmlspecialchars($mon_name), "</li><li>Serial #: ", htmlspecialchars($mon_serial_no), "</li></ul>";
			if ($mon_powered!="" ) echo "Display powered ".($mon_powered==0?"off":"on")."<br/>";
		
			if ($mon_pict_ar=="" || $mon_pict_ar=="x:x") $mon_pict_ar="[unknown]";
			if ($mon_width!="" && $mon_height!="") echo "<br/>Display size: $mon_width x $mon_height cm <br/>Aspect ratio: $mon_pict_ar <br/>";
			if ($mon_underscan!="" && $mon_underscan==0) echo "Underscan not supported<br/>"; else echo "Underscan supported<br/>";
		}else{
			echo "<b>Display not detected</b><br/>This doesn't mean that the display is not working, it means that the display provides no feed-back.<br/>";
		}
		echo "<br/>\n";
				
	}
}

include ("final.php");
?>
